'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.NPM_CONFIG = undefined;
exports.default = configNpmInChina;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

require('colors');

var _osEnvSetter = require('os-env-setter');

var _osEnvSetter2 = _interopRequireDefault(_osEnvSetter);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NPM_CONFIG = exports.NPM_CONFIG = {
    'registry': 'https://registry.npm.taobao.org',
    'disturl': 'https://npm.taobao.org/dist'
};

var NPM_ENV = {
    'SASS_BINARY_SITE': 'https://npm.taobao.org/mirrors/node-sass',
    'ELECTRON_MIRROR': 'https://npm.taobao.org/mirrors/electron/'
};

function setupNpmConfig(key, val) {
    return (0, _utils.execCmd)('npm config set ' + key + ' "' + val + '"').then(function () {
        console.log('  \u5DF2\u8BBE\u7F6Enpm\u53D8\u91CF: ' + key + '=' + val);
        if (key === 'registry') {
            console.warn('  # WARN: # 请注意更改了 npm "registry" 之后,  "npm publish" 将会失败.'.yellow);
            console.warn('           (手动设回: --registry https://registry.npmjs.org )'.yellow);
        }
    });
}

function setupNpmEnvs() {
    return (0, _osEnvSetter2.default)(NPM_ENV).then(function (_ref) {
        var writtenFile = _ref.writtenFile,
            writtenEnvs = _ref.writtenEnvs;

        if (writtenEnvs.length) {
            writtenEnvs.forEach(function (_ref2) {
                var key = _ref2.key,
                    value = _ref2.value;

                console.log('  \u5DF2\u8BBE\u7F6E\u73AF\u5883\u53D8\u91CF: ' + key + '=' + value);
            });
        }
    });
}

function configNpmInChina() {
    return (0, _utils.execCmd)('npm -v').then(function () {
        console.log('# 配置 npm: #');
        return (0, _utils.sequencePromises)(_lodash2.default.map(NPM_CONFIG, function (val, key) {
            return function () {
                return setupNpmConfig(key, val);
            };
        }).concat(setupNpmEnvs));
    }, function () {
        return Promise.reject('# 配置 npm: # 未安装, 跳过.');
    });
}