'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = configNpmInChina;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _configNpmInChina = require('./config-npm-in-China');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 拷贝一份npm配置到yarn配置中，使得用yarn安装包时也能正常工作

function setupYarnConfig(key, val) {
    return (0, _utils.execCmd)('yarn config set ' + key + ' "' + val + '"').then(function () {
        return console.log('  \u5DF2\u8BBE\u7F6Eyarn\u53D8\u91CF: ' + key + '=' + val);
    });
}

function configNpmInChina() {
    return (0, _utils.execCmd)('yarn --version').then(function () {
        console.log('# 配置 yarn: #');
        return (0, _utils.sequencePromises)(_lodash2.default.map(_configNpmInChina.NPM_CONFIG, function (val, key) {
            return function () {
                return setupYarnConfig(key, val);
            };
        }));
    }, function () {
        console.log('# 配置 yarn: # 未安装, 跳过.');
    });
}