'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.execCmd = execCmd;
exports.sequencePromises = sequencePromises;
exports.negativePromise = negativePromise;

var _child_process = require('child_process');

var _child_process2 = _interopRequireDefault(_child_process);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function execCmd(cmd) {
    cmd += ' 2>&1';
    return new Promise(function (resolve, reject) {
        var cp = _child_process2.default.exec(cmd, function (err, stdout) {
            if (err) {
                reject('#CMD#: ' + cmd + '\n' + stdout);
            } else {
                resolve(stdout);
            }
        });
    });
}

function sequencePromises(promiseGenerators) {
    var result = Promise.resolve();
    promiseGenerators.forEach(function (promiseGen) {
        result = result.then(promiseGen);
    });
    return result;
}

function negativePromise(promise) {
    return new Promise(function (resolve, reject) {
        promise.then(reject, resolve);
    });
}